	title "                              ###########  TowerLight  ###########"
	
	list	p=10F202,  c=123,  st=ON,  mm=ON,   n=49
	#include <p10f202.inc>

	__config _MCLRE_OFF & _CP_OFF &  _WDT_OFF
	
	radix dec

;===========================================================================
;===========================================================================
;=====   CUSTOMIZABLE SETTINGS   ===========================================
;===========================================================================
;===========================================================================
;=================                                      ====================
;=====  >>>>>>>>>>>>>  Set the TowerLight Times   <<<<<<<<<<<<<<<<<<< ======
;=================                                      ====================
;===========================================================================

; 	SET HERE the TowerLight >>> Off Time <<< in milliseconds

_TowerLightOffTime        equ    200


; 	SET HERE the TowerLight >>> Fade Up Time <<< in milliseconds

_TowerLightFadeUpTime     equ    600     

; 	SET HERE the TowerLight >>> Bright Time <<< in milliseconds

_TowerLightBrightTime     equ    700     

; 	SET HERE the TowerLight >>> Fade Down Time <<< in milliseconds

_TowerLightFadeDownTime   equ    500     


;===========================================================================
;===========================================================================
;===========================================================================

	
	
;###########################################################################
;###########################################################################
;###                                                                     ###
;###                  Do NOT change the below                            ###
;###       unless you are SURE you know what you are doing!              ###
;###                                                                     ###
;###                         WAIT! ....                                  ###
;###                                                                     ###
;###                      ARE YOU SURE???                                ###
;###                                                                     ###
;###                  ARE YOU REALLY SURE????                            ###
;###                                                                     ###
;###                       THINK AGAIN!                                  ###
;###                                                                     ###
;###             DO YOU REALLY WANT TO RISK IT???????                    ###
;###                                                                     ###
;###########################################################################
;###########################################################################

       ; Internal Oscillator is 4 MHz and divided it to 1 MHz for CPU
_ClkIn              equ    1000000

_CycleTimeUSecs     equ    1000000 / _ClkIn

_PreScalerRatio	    equ	   64  		; 32 to 1
                         
; --------------------------------------------------------------------------
; following determines the Option Register bits for the pre-scaler

i = 0
    while (2<<i) < _PreScalerRatio
i += 1
        endw
_PreScalerBits	    equ    i
   
   messg #v(_PreScalerBits)  prescaler bits

; --------------------------------------------------------------------------

        
        
_T0ToggleTime          equ    _CycleTimeUSecs *  _PreScalerRatio  
_TLCycleTime	       equ    _TowerLightOffTime + _TowerLightFadeUpTime + _TowerLightBrightTime + _TowerLightFadeDownTime

_TLOffCount            equ    (_TowerLightOffTime        * 1000) / _T0ToggleTime
_TLFadeUpCount         equ    (_TowerLightFadeUpTime     * 1000) / _T0ToggleTime
_TLBrightCount         equ    (_TowerLightBrightTime     * 1000) / _T0ToggleTime
_TLFadeDownCount       equ    (_TowerLightFadeDownTime   * 1000) / _T0ToggleTime

;  calc fade timing 
_TLFadeUpStepCount     equ   (_TLFadeUpCount + (128/2))/128       ; round up on the divide
_TLFadeDownStepCount   equ   (_TLFadeDownCount + (128/2))/128     ; round up on the divide

_PwmCycleTime          equ   _T0ToggleTime * 128
_PwmFrequency          equ   1000000/_PwmCycleTime

_MaxPwmLevel           equ   0x7F
	  		
	nolist
 messg .
 messg                           TowerLight Off Time  		= #v(_TowerLightOffTime) milliseconds 
 messg                           TowerLight Fade Up Time 	= #v(_TowerLightFadeUpTime) milliseconds 
 messg                           TowerLight Bright Time 	= #v(_TowerLightBrightTime) milliseconds
 messg                           TowerLight Fade Down Time 	= #v(_TowerLightFadeDownTime) milliseconds 
 messg .
 messg .
 messg                           TowerLight Cycle time		= #v(_TLCycleTime) millisecs
 messg .
 messg                           TMR0 toggle time		= #v(_T0ToggleTime) usecs 
 messg				 PWM Cycle Time			= #v(_PwmCycleTime) usecs
 messg				 PWM Frequency			= #v(_PwmFrequency) Hz
 messg                           Off count			= #v(_TLOffCount) 
 messg                           Fade Up count			= #v(_TLFadeUpCount) 
 messg                           Bright count			= #v(_TLBrightCount) 
 messg                           Fade Down count		= #v(_TLFadeDownCount) 
 messg .
 messg                           Fade Up Step Count		= #v(_TLFadeUpStepCount)
 messg                           Fade Down Step Count		= #v(_TLFadeDownStepCount)
 messg .
 
	list
	
	radix  hex

#define ToW	0 
#define	ToF	1
	

	
; ==========================================================================
; === Registers  ===========================================================
; ==========================================================================

	cblock 0x10

	LHFlags
	ModeCntrUpper
	ModeCntrHigh
	ModeCntrLow
	FadeStepCntrHigh
	FadeStepCntrLow
	FadeLevel
	PWMcntr
	PWMOnCnt
	PWMOffCnt
	RunCnt
	endc


#define	LHF_FadingUp		LHFlags,0
;				Indicates fading up light

#define	LHF_Bright		LHFlags,1
;				Indicates fading up light

#define	LHF_FadingDown		LHFlags,2
;				Indicates fading up light


#define	LHF_FadeComplete	LHFlags,6
;				Indicates fade complete (fade=0 or =07F)

#define	LHF_Tmr0BitZeroSave	LHFlags,7
;				Indicates last TMR0 low bit value
;				  so we know when it changes

	page
	
	org 0

Start:
;	Upon gettng control at adr 0, W will have been loaded with the 
;	Oscillator calibration value from x'1FF'. 
	movwf	OSCCAL		;Set calibration value in OSCCAL

	movlw   b'10000000' 
			; 1 - Wake up on pin change - disabled
			; 0 - Enable weak pull-ups - enabled
			; 0 - Timer 0 clock source - internal
			; 0 - Timer0 Source Edge Select - Low to High
			; 0 - Prescaler assigned to - Timer0
			; xxx - Prescaler rate
	iorlw	_PreScalerBits	
	option
	
	clrf	TMR0
	clrf	STATUS	

	movlw	b'00001110'  	;set GP0 for output
	tris	GPIO		; TRIS reg 6
	clrf	GPIO		; set outputs low (off)
	
	clrf	LHFlags		; indicate at end of dark
	clrf	ModeCntrUpper
	clrf	ModeCntrHigh
	clrf	ModeCntrLow
	incf	ModeCntrLow,ToF
	clrf	FadeLevel
	
Loop:
	btfsc	LHF_Tmr0BitZeroSave     ; last loop thru, was TMR0,0 set?
	goto	Loop0010		; go if so
	
	; last loop thru, TMR0,0 = 0
	btfss	TMR0,0			; TMR0,0 = 1?	
	goto	Loop			; go if not
	
	; bit has changed
	bsf	LHF_Tmr0BitZeroSave	; set saved value
	goto 	TimeToCheck		; go check counters
	
Loop0010:  ; last loop thru, TMR0,0 = 1
	btfsc	TMR0,0			; TMR0,0 = 0?
	goto	Loop			; go if not
	
	; bit has changed
	bcf	LHF_Tmr0BitZeroSave	; set saved value
	
	
TimeToCheck:
;   -----------------------------------------------------------------------
	nolist
 messg	   when here, #v(_T0ToggleTime) usecs has passed <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 	list
;   -----------------------------------------------------------------------

;  check if Mode count complete
	
	decfsz	ModeCntrLow,ToF		; decr low byte & skip if zero
	goto	Loop0100                ; not zero so more to count for Mode

	movf	ModeCntrHigh,ToF	; is high byte zero?
	btfsc	STATUS,Z		; skip if not
	goto	Loop0030		; br if zero
	decf	ModeCntrHigh,ToF	; decr high byte of count
	goto	Loop0100
	
Loop0030:
	movf	ModeCntrUpper,ToF	; is it zero?
	btfsc	STATUS,Z		; skip if not
	
	goto	Loop1000		; DONE COUNTING for MODE  <<<<<<
	
	decf	ModeCntrUpper,ToF	; decr upper byte of count


Loop0100:

;  Mode count NOT complete, so 
;     check if Fade STEP COUNT complete

;  check flags first

	btfsc	LHF_FadeComplete	; Fade complete? - skip if not
	goto 	Loop			; no need for more PWM simulation
	
	btfsc	LHF_Bright		; Bright? - skip if not
	goto	Loop			;   loop if so

	btfsc	LHF_FadingUp		; Fading up? - skip if not
	goto	Loop0140		; now Fading Up 
	
	btfss	LHF_FadingDown		; Fading down? - skip if SO
	goto	Loop			; not Fading Down, must be off


Loop0130:    ; Here if Fading Down		

	decfsz	FadeStepCntrLow,ToF	; decr low byte & skip if zero
	goto	Loop0300		; not time to change level

	movf	FadeStepCntrHigh,ToF	; is high byte zero?
	btfsc	STATUS,Z		; skip if not
	goto	Loop0135		; done counting for fade step
	decf	FadeStepCntrHigh,ToF	; decr upper byte of count
	goto	Loop0300		; not time to change level

Loop0135:   ; time to decrease output level by 1

	decf	FadeLevel,ToF		; decr level
	btfss	STATUS,Z		; skip if zero
	goto	Loop0137		; go if NOT zero
	
	bsf	LHF_FadeComplete	; set fade complete flag
	bcf	GPIO,0			; turn off LED	
	goto 	Loop
	
Loop0137:
	movlw	low(_TLFadeDownStepCount)
	movwf	FadeStepCntrLow
	movlw	high(_TLFadeDownStepCount)
	movwf	FadeStepCntrHigh
	goto	Loop0160
	
	
Loop0140:   ; here if Fading Up

	decfsz	FadeStepCntrLow,ToF		
	goto	Loop0300		; not time to change level

	movf	FadeStepCntrHigh,ToF
	btfsc	STATUS,Z		
	goto	Loop0145		; done counting for fade step
	decf	FadeStepCntrHigh,ToF	; decr upper byte of count
	goto	Loop0300		; not time to change level

Loop0145:   ; time to increase output level by 1

	incf	FadeLevel,ToF		; increment and set new level
	movlw	_MaxPwmLevel		; at max count?
	subwf	FadeLevel,ToW		; 
	btfss	STATUS,Z		; skip if at max count
	goto	Loop0147		; go if NOT
	
	bsf	LHF_FadeComplete	;set fade coomplete flag
	bsf	GPIO,0			;turn on LED	
	goto 	Loop
	
Loop0147:
	movlw	low(_TLFadeUpStepCount)
	movwf	FadeStepCntrLow
	movlw	high(_TLFadeUpStepCount)
	movwf	FadeStepCntrHigh


Loop0160:

	movf	FadeLevel,ToW		; get new level
	movwf	PWMOnCnt		; set as on count
	movwf	PWMOffCnt		
	comf	PWMOffCnt,ToF		; set off count
	bcf	PWMOffCnt,7		; count to 128
	goto	Loop0300		; go start PWM sequence


Loop0300:
;  check if PWM count complete, if so, change output level

	decfsz	PWMcntr,ToF
	goto	Loop
Loop0302:			;label for register trace	
	btfsc	GPIO,0  		; is LED on
	goto	Loop0320		; br if so

Loop0310:	
	movf	PWMOnCnt,ToW		; get on count
	movwf	PWMcntr
	incf	PWMcntr,ToF		; preset for decfsz
	bsf	GPIO,0			;turn on LED 	
	goto	Loop
	
Loop0320:	
	movf	PWMOffCnt,ToW		; get off count
	movwf	PWMcntr
	incf	PWMcntr,ToF		; preset for decfsz
	bcf	GPIO,0		;turn off LED	
	goto	Loop




;   -----------------------------------------------------------------------
	; count for current mode has decr to zero
;   -----------------------------------------------------------------------

Loop1000:
	bcf	LHF_FadeComplete	; clear fade_complete flag
	
	btfss	LHF_FadingUp		;Is light fading up?
	goto	Loop2000		;Br if not

;  Light was fading up, now set for bright

	bcf	LHF_FadingUp		;clear stat of fading up
	bsf	LHF_Bright		;set bright
	bsf	GPIO,0			;turn on LED
	
	movlw	upper(_TLBrightCount)	;get count for bright time
	movwf	ModeCntrUpper
	movlw	high(_TLBrightCount)	;get count for bright time
	movwf	ModeCntrHigh
	movlw	low(_TLBrightCount)	;get count for bright time
	movwf	ModeCntrLow
	goto	Loop


Loop2000:
	btfss	LHF_Bright		;Is light bright?
	goto	Loop3000		;Br if not

;  Light was bright, now set for fading down
	bcf	LHF_Bright		;clear Mode of bright
	bsf	LHF_FadingDown		;set fading down

	movlw	upper(_TLFadeDownCount)	;get count for Fade time
	movwf	ModeCntrUpper
	movlw	high(_TLFadeDownCount)	;get count for Fade time
	movwf	ModeCntrHigh
	movlw	low(_TLFadeDownCount)	;get count for Fade time
	movwf	ModeCntrLow

	movlw	_MaxPwmLevel
	movwf	FadeLevel
	
	goto	Loop0137
		

Loop3000:
	btfss	LHF_FadingDown		;is light fading down?
	goto	Loop4000		;br if not
	
;  Light was fading down, now set for dark (constant dim)
	
	bcf	LHF_FadingDown		;clear Mode of fading down

	movlw	upper(_TLOffCount)	;get count for dim time
	movwf	ModeCntrUpper
	movlw	high(_TLOffCount)	;get count for dim time
	movwf	ModeCntrHigh
	movlw	low(_TLOffCount)	;get count for dim time
	movwf	ModeCntrLow

	clrf	FadeLevel
	bcf	GPIO,0			;turn off LED
	goto	Loop


Loop4000:
;  If it's not any of the other three, light must be dim
;     So set for Fade Up

	bsf	LHF_FadingUp		;set fading up
	
	movlw	upper(_TLFadeUpCount)	;get count for Fade time
	movwf	ModeCntrUpper
	movlw	high(_TLFadeUpCount)	;get count for Fade time
	movwf	ModeCntrHigh
	movlw	low(_TLFadeUpCount)	;get count for Fade time
	movwf	ModeCntrLow
	
	clrf	FadeLevel
	goto	Loop0147

	end
